var Accessory = require('../').Accessory;
var Service = require('../').Service;
var Characteristic = require('../').Characteristic;
var uuid = require('../').uuid;

var http = require('http');

var options = {
    host: '192.168.0.250',
    path: ''
}

var check_flag = 0;

// here's a fake hardware device that we'll expose to HomeKit
var MEGAD_LIGHT = {
  powerOn: false,
  brightness: 100, // percentage
  
  setPowerOn: function(on) { 
    //console.log("Turning the light %s!", on ? "on" : "off");

    MEGAD_LIGHT.powerOn = on;

    //console.log(on);

	if ( check_flag == 0 )
	{


	var status = 0;
	if ( on == "true" || on == 1 )
	status = 1;
	
	options['path'] = "/key.php?key_label=light_kitchen&key_pio=" + status;

	var request = http.request(options, function (res) {
	    var data = '';
	    res.on('data', function (chunk) {
	        data += chunk;
	    });
	    res.on('end', function () {
	        //console.log(data);
	        //console.log("-----!-----");
	    });
	});
	request.on('error', function (e) {
	    console.log(e.message);
	});
	request.end();
	}

	check_flag = 0;

  },
  setBrightness: function(brightness) {
    console.log("Setting light brightness to %s", brightness);
    MEGAD_LIGHT.brightness = brightness;
  },
  identify: function() {
    console.log("Identify the light!");
  }
}

// Generate a consistent UUID for our light Accessory that will remain the same even when
// restarting our server. We use the `uuid.generate` helper function to create a deterministic
// UUID based on an arbitrary "namespace" and the word "light".
var lightUUID = uuid.generate('hap-nodejs:accessories:megad-kitchen');

// This is the Accessory that we'll return to HAP-NodeJS that represents our fake light.
var light = exports.accessory = new Accessory('Light', lightUUID);

// Add properties for publishing (in case we're using Core.js and not BridgedCore.js)
light.username = "1A:2B:3C:4D:5E:04";
light.pincode = "031-45-154";

// set some basic properties (these values are arbitrary and setting them is optional)
light
  .getService(Service.AccessoryInformation)
  .setCharacteristic(Characteristic.Manufacturer, "Oltica")
  .setCharacteristic(Characteristic.Model, "Rev-1")
  .setCharacteristic(Characteristic.SerialNumber, "A1S2NASF88EW");

// listen for the "identify" event for this Accessory
light.on('identify', function(paired, callback) {
  MEGAD_LIGHT.identify();
  callback(); // success
});

// Add the actual Lightbulb Service and listen for change events from iOS.
// We can see the complete list of Services and Characteristics in `lib/gen/HomeKitTypes.js`
light
  .addService(Service.Lightbulb, "Кухня") // services exposed to the user should have "names" like "Fake Light" for us
  .getCharacteristic(Characteristic.On)
  .on('set', function(value, callback) {
    MEGAD_LIGHT.setPowerOn(value);
    callback(); // Our fake Light is synchronous - this value has been successfully set
  });

// We want to intercept requests for our current power state so we can query the hardware itself instead of
// allowing HAP-NodeJS to return the cached Characteristic.value.
light
  .getService(Service.Lightbulb)
  .getCharacteristic(Characteristic.On)
  .on('get', function(callback) {
    
    // this event is emitted when you ask Siri directly whether your light is on or not. you might query
    // the light hardware itself to find this out, then call the callback. But if you take longer than a
    // few seconds to respond, Siri will give up.
    
    var err = null; // in case there were any problems
    
    if (MEGAD_LIGHT.powerOn) {
      console.log("Are we on? Yes.");
      callback(err, true);
    }
    else {
      console.log("Are we on? No.");
      callback(err, false);
    }
  });

// also add an "optional" Characteristic for Brightness
light
  .getService(Service.Lightbulb)
  .addCharacteristic(Characteristic.Brightness)
  .on('get', function(callback) {
    callback(null, MEGAD_LIGHT.brightness);
  })
  .on('set', function(value, callback) {
    MEGAD_LIGHT.setBrightness(value);
    callback();
  })


setInterval(function() {

/*
  .on('set', function(value, callback) {
    MEGAD_LIGHT.setPowerOn(true);
    callback(); // Our fake Light is synchronous - this value has been successfully set
  });
*/
//    .setCharacteristic(Characteristic.powerOn, true);

	options['path'] = "/key.php?get_key=light_kitchen";

	var request = http.request(options, function (res) {
	    var data = '';
	    res.on('data', function (chunk) {
	        data += chunk;
	    });
	    res.on('end', function () {
	        //console.log(data);
		check_flag = 1;
		if ( data == 1 )
		light.getService(Service.Lightbulb).setCharacteristic(Characteristic.On, true);
		else
		light.getService(Service.Lightbulb).setCharacteristic(Characteristic.On, false);
	    });
	});
	request.on('error', function (e) {
	    console.log(e.message);
	});
	request.end();
	MEGAD_LIGHT.powerOn

}, 28000);
